# MeshPart

MeshPart : `BasePart`

## Overview

This object represents a custom mesh based on BasePart, which is simulated in the physics engine based on the mesh's shape.

The MeshId and TextureID properties determines the shape and texture of MeshPart

## Properties

### DoubleSided

`boolean`

This property determines whether the mesh is rendered on both faces.

For cases like paper, leaves, or thin metal plates that need to be visible from both sides, setting this property to true renders both the front and back faces of the mesh, ensuring the surface is visible from any direction.

However, as double-sided rendering can increase load on GPU, it should only be used when necessary.

#### Code Samples

```lua
local MeshPart = script.Parent

print(MeshPart.DoubleSided)
```

### EnableMeshShadowDetails

`boolean`

Determines whether to enable the shadow detail setting for the MeshPart.

When this option is enabled, the mesh's individual setting takes priority over the Lighting service's global setting.

#### Code Samples

### MeshId

`string`

This property sets the mesh asset to be displayed on the MeshPart.

#### Code Samples

```lua
local MeshPart = script.Parent

print(MeshPart.MeshId)
```

### MeshShadowDetailLevel

`Enum.ShadowDetailLevel`

Setting the shadow detail level of the MeshPart.

If the value of MeshShadowDetailLevel is set to Original, it render shadows with precise detail matching the original mesh shape. Medium or Low settings render shadows in simpler forms.

#### Code Samples

### MeshSize

`Vector3`

This property indicates the original size of the mesh.

#### Code Samples

```lua
local MeshPart = script.Parent

print(MeshPart.MeshSize)
```

### TextureId

`string`

This property sets the texture asset to be displayed on the MeshPart.

#### Code Samples

```lua
local MeshPart = script.Parent

print(MeshPart.TextureId)
```

## Methods

## Events


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.overdare.com/development/api-reference/classes/meshpart.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
